#include <LEDA/graph/graph.h>
#include <LEDA/graph/node_array.h>
#include <LEDA/core/list.h>
#include <LEDA/core/array.h>
#include <LEDA/core/string.h>
#include <LEDA/graphics/graphwin.h>
#include <LEDA/numbers/integer.h>
#include <iostream>

using namespace leda;
using namespace std;

void tree(graph &G,GRAPH<list<node>,edge> &T,list< list<node> > &F,list<edge> &le);
void ope(graph &G,GRAPH<list<node>,edge> &T,node v,list< list<node> > &U_A,list<node> &C,list<node> &L,list<node> &S,list< list<node> > &F,list<edge> &le);
void c_component(graph &G,node_array<int> &node_ord,list<node> &C,list<node> &L,node v);
void N_G(list<node> &L,list<node> &S);
int existU_A(list< list<node> > &U_A,list<node> &S);
void existX(graph &G,GRAPH<list<node>,edge> &T,list<node> &X,list< list<node> > &U_A,list<node> &L,list<node> &S,list< list<node> > &F,list<edge> &le);
void replace(graph &G,GRAPH<list<node>,edge> &T,node v,list< list<node> > &U_A,list<node> &L,list<node> &S,list< list<node> > &F,list<edge> &le);
void rep(graph &G,GRAPH<list<node>,edge> &T,list<node> &X_1,list<node> &X_2,list<node> &S,list< list<node> > &F,node v,list<edge> &le);
void rep2(graph &G,GRAPH<list<node>,edge> &T,list<node> &X_1,list<node> &X_2,list<node> &S,list< list<node> > &F,node v,list<edge> &le);
void f_edge(GRAPH<list<node>,edge> &T,list<node> &kl,node v,list< list<node> > &U_A);
edge v_w_edge(graph &G,node v,node w);

void triangulation(graph &G,graph &H,list< list<node> > &F,list<edge> &le);
void operation(graph &G,graph &H,node v,list< list<node> > &F,list<edge> &le);
int edge_exist(node v1,node v2);
void c_component(graph &G,graph &H,node_array<int> &node_ord,list<node> &C,list<node> &L);
void add(graph &G,graph &H,list< list<node> > &F,list<node> &L,list<node> &L2,list<edge> &le);

void lemma3(graph &G,GRAPH<list<node>,edge> &T,array<int> &ar);
void ch_p(graph &G,GRAPH<list<node>,edge> &T,list< list<node> > &F,array<int> &ar,list<edge> &le);
void calculation(array<int> &ar,list<int> L1,list<int> L2,int n);
void Theorem2(graph &G,GRAPH< list<node>,edge> &T,list< list<node> > &F,edge e,array<int> &ar);
void cul2(array<int> &ar,array<int> &ar1,array<int> &ar2,array<int> &ark,int n);
void m_n(GRAPH<list<node>,edge> &T,graph &G,node_array<int> &na,node v,node w);
void m_G(graph &G,graph &G1,node_array<int> &na);
void Kr(graph &G,GRAPH<list<node>,edge> &T,node v,node w,array<int> &ar);
void calk(int size,array<int> &ar,int n);
void Theorem1(graph &G,GRAPH<list<node>,edge> &T,edge e,array<int> &ar);
edge ChoiseFunction(graph &G,GRAPH<list<node>,edge> &T,list< list<node> > &F);
void contraction(graph &G,edge e);
int zentan_haba(GRAPH<list<node>,edge> &T, node v, node w);
edge find_tree_edge(GRAPH<list<node>,edge> &T,int N);

double equation = 0;

int main(){
  graph G,H;
  G.read("graph.gw");
  H=G;
  GRAPH<list<node>,edge> T;
  G.make_undirected();
  T.make_undirected();
  H.make_undirected();

  list< list<node> > F;
  list<edge> le;
  //H=(V,E+F) is a minimal triangulation of G=(V,E)

  T.clear();
  F.clear();
  le.clear();
  clock_t start_t = clock();
  triangulation(G,H,F,le);
  clock_t end_t = clock();
  H.write("out1.gw");

  /********************************
  list_item it,its;
  forall_items(it,F){
    forall_items(its,F[it])
      cout << F[it][its] << " ";
    cout << endl;
  }
  ********************************* */

  //T is augmented clique-tree of G
  tree(H,T,F,le);
  T.write("out.gw");
  edge e;
  forall(e,le)
    H.del_edge(e);

  /* *************************
  cout << " T[i] " << endl;
  edge i;
  forall_edges(i,T){
    cout << T[i] << endl;
    cout << i << endl;
    cout << endl;
  }
    cout << endl;
  ***************************** */  
  /*
  cout << " -------T--------" << endl;
  edge e5;
  forall_edges(e5,T){
    cout << "-------ttt-------" << endl;
    node v5 = T.source(e5);
    node w5 = T.opposite(v5,e5);
    cout << v5 << endl;
    T[v5].print(cout,' ');
    cout << endl;
    cout << w5 << endl;
    T[w5].print(cout,' ');
    cout << endl;
    int count =0;
    node k;
    forall(k,T[v5])
      if(T[w5].search(k) != nil)
	count++;
  }
  cout << "-------T end -----------" << endl;
  node b;
  forall_nodes(b,T){
    cout << b << " : " ;
    T[b].print(cout,' ');
    cout << endl;
  }
  */

  // /*
  //thickness
  list_item it = F.first();
  int th_max = 0;
  while(it != nil){
    list_item it1 = F[it].first();
    list_item it2 = F[it].succ(it1);
    node v = F[it][it1];
    node w = F[it][it2];
    int th_count =0;
    edge e;
    forall_edges(e,T){
      node n1 = T.source(e);
      node n2 = T.opposite(n1,e);
      if(T[n1].search(v) && T[n1].search(w) && T[n2].search(v) && T[n2].search(w) )
	th_count++;
    }
    if(th_count > th_max)
      th_max = th_count;
    it = F.succ(it);
  }
  
  cout << "thickness : " << th_max << endl;
  //  */

  /*  
  cout << "----node----" << endl;
  node v;
  forall_nodes(v,H){
    cout << v << ": ";
    edge ee;
    forall_adj_edges(ee,v)
      cout << H.opposite(v,ee) << " ";
    cout << endl;
  }
  cout << endl;
  cout << "-----F-----" << endl;
  list_item it = F.first();
  while(it != nil){
    F[it].print(cout,' ');
    cout << endl;
    it=F.succ(it);
  }

  cout << "T nodes:" << T.number_of_nodes() << endl;
  forall_nodes(v,T)
    cout << T[v].size() << " " << endl;
  cout << endl;
  */

  int n = H.number_of_nodes();
  array<int> ar(n+1);
  for(int i=0;i<n+1;i++)
    ar[i] = 0;
  
  /***************************************
  GraphWin gw1(H,"main-H-");
  gw1.display(window::center,window::center);
  gw1.edit();
  ******************************************/

  clock_t start = clock();
  ch_p(H,T,F,ar,le);
  clock_t end = clock();
  for(int j=n;j>0;j--){
    cout << ar[j] << "x^"<< j ;
    if(j != 1)
      if(ar[j-1] > 0)
	cout << " + " ;
      else{
	cout << " - " ;
	ar[j-1] = ar[j-1] * (-1);
      }
  }
  cout << endl;

  double elapsed = (double)(end - start)/CLOCKS_PER_SEC;
  double elapsed_t = (double)(end_t - start_t)/CLOCKS_PER_SEC;
  cout << "time : " << elapsed - equation + elapsed_t<< "(s)" << endl;
  
}



/* ******************************************************
   clique-tree$B$r:n@.(B
********************************************************* */


void tree(graph &G,GRAPH<list<node>,edge> &T,list< list<node> > &F,list<edge> &le){
  node q;
  //forall_nodes(q,G)
  //cout << q << endl;
  //cout << "##################" << endl;
  list< list<node> > U_A;
  list<node>C,L,S;
  U_A.clear();
  node w = T.new_node();
  node v;
  forall_nodes(v,G)
    T[w].append(v);

  forall_nodes(v,G){
    // cout << "start:"<< v << ";" << G.degree(v)<< endl;
    ope(G,T,v,U_A,C,L,S,F,le);
    node i,h;
    //forall_nodes(i,T){
    //forall(h,T[i])
    //cout << h << endl;
    //cout << endl;
    //}
  }
}

void ope(graph &G,GRAPH<list<node>,edge> &T,node v,list< list<node> > &U_A,list<node> &C,list<node> &L,list<node> &S,list< list<node> > &F,list<edge> &le){
  C.clear();

  //C_G(N_H[i])
  node_array<int> C_G(G,1);
  node w;
  forall_adj_nodes(w,v)
    C_G[w]=0;
  list_item it,its;
  forall_items(it,U_A)
    if(U_A[it].search(v) != nil)
      forall_items(its,U_A[it])
	C_G[ U_A[it][its] ] = 0;
  C_G[v]=0;

  //C_G(N_H[v])$B$r(Blist C$B$KJ]B8$9$k(B
  forall_nodes(w,G)
    if(C_G[w]==1)
      C.append(w);
  while( !C.empty() ){
    L.clear();
    S.clear();
    list_item cit = C.first();
    c_component(G,C_G,C,L,C[cit]);
    //cout << "L:" ;
    //L.print(cout,' ');
    //cout << endl;
    N_G(L,S);
    if(!existU_A(U_A,S))
      U_A.append(S);

    // bag X in T containing v and S and C
    list<node> X;
    forall(w,S)
      X.append(w);
    if(X.search(v) == nil)
      X.append(v);

    /* bag
    forall(w,L)
      if(X.search(w) == nil)
	X.append(w);
    */
    existX(G,T,X,U_A,L,S,F,le);
  }

}

//connected component C in C_G(N_H[v])
void c_component(graph &G,node_array<int> &node_ord,list<node> &C,list<node> &L,node v){

  node_ord[v] = 0;
  L.append(v);
  C.remove(v);

  node w;
  //cout << "v : " << v << endl;
  forall_adj_nodes(w,v){
    // cout << w << endl;
    if( node_ord[w]==1 ){
      c_component(G,node_ord,C,L,w);
    } }
}

//N_G(C)$B$r(BS$B$KJ]B8$9$k(B
void N_G(list<node> &L,list<node> &S){
  node v,w;
  forall(v,L){
    forall_adj_nodes(w,v){
      if(S.search(w)==nil)
	S.append(w);
    }
  }
  forall(v,L)
    S.remove(v);
}


int existU_A(list< list<node> > &U_A,list<node> &S){

  list_item S_it = S.first();
  list_item U_it = U_A.first();
 
  list<node> K;
  node v;
  forall(K,U_A){
    int i=0;
    forall(v,S)
      if(K.search(v) != nil)
	i++;
    if(i==S.size())
      return 1;
  }
  return 0;
}

void existX(graph &G,GRAPH<list<node>,edge> &T,list<node> &X,list< list<node> > &U_A,list<node> &L,list<node> &S,list< list<node> > &F,list<edge> &le){

  node v,w,x;
  list<node> L1;
  forall_nodes(v,T){
  L1.clear();
    int i=0;
    int j=0;
    forall(w,X)
      if(T[v].search(w) != nil)
	i++;
    forall(x,L)
      if(T[v].search(x) != nil){
      L1.append(x);
	j++;
      }
    if(i==X.size() && j > 0)
      replace(G,T,v,U_A,L1,S,F,le);
  }
}


void replace(graph &G,GRAPH<list<node>,edge> &T,node v,list< list<node> > &U_A,list<node> &L,list<node> &S,list< list<node> > &F,list<edge> &le){
  list<node>X_1;
  list<node>X_2;
  X_1.clear();
  X_2.clear();

  //X_1$B:n@.(B
  node_array<int> n1(G,0);
  node w;
  forall(w,T[v])
    n1[w]=1;

  forall(w,L)
    if(n1[w] == 1)
      n1[w] = 2;

  forall(w,S)
    X_1.append(w);
  forall_nodes(w,G)
    if(n1[w] == 2 && X_1.search(w)==nil)
      X_1.append(w);


  //X_2$B:n@.(B
  node_array<int> n2(G,1);
  forall(w,L)
    n2[w] = 0;
  forall(w,T[v])
    if(n2[w]==1)
      X_2.append(w);


  list<node> kl;
  kl.clear();
  if(U_A.size() > 1)
    f_edge(T,kl,v,U_A);
  else
    if(U_A.size() == 1)
      kl = U_A.head();
  /*
  node m;
  int count =0;
  if(kl.size() != 0)
    forall(m,kl){
      if(X_1.search(m) != nil)
	count++;
    }
  if(count == kl.size() )
    rep(G,T,X_1,X_2,S,F,v,le);
  else
    rep(G,T,X_2,X_1,S,F,v,le);
  */

  node m,m1,l;
  int i=0,j=0;
  //cout << "T.degree() : "<< T.degree(v) << endl; 
  if(T.degree(v)==1)
    forall_adj_nodes(m,v){
      forall(l,T[m]){
	if(X_1.search(l) != nil)
	  i++;
	if(X_2.search(l) != nil)
	  j++;
      }
    if(i != j)
      break;
  }
  else
    if(T.degree(v) >= 2){
      rep2(G,T,X_1,X_2,S,F,v,le);
      return;
    }
  if(i > j)
    rep(G,T,X_1,X_2,S,F,v,le);
  else 
    rep(G,T,X_2,X_1,S,F,v,le);
  
}

void rep2(graph &G,GRAPH<list<node>,edge> &T,list<node> &X_1,list<node> &X_2,list<node> &S,list< list<node> > &F,node v,list<edge> &le){

  T[v].clear();
  node w1;
  forall(w1,X_1)
    T[v].append(w1);
  
  node v1 = T.new_node();
  T[v1].clear();
  node w2;
  forall(w2,X_2)
    T[v1].append(w2);
  
  int bre =0;

  edge e = T.new_edge(v,v1);
  list_item it = S.first();
  list_item itf;
  while(it != nil){
    list_item it_succ = S.succ(it);
    while(it_succ != nil){
      edge e1 = v_w_edge(G,S[it],S[it_succ]);
      if(le.search(e1) != nil){
	  T[e] = e1;
	  bre++;
	}
      it_succ = S.succ(it_succ);
    }
    it = S.succ(it);
    if(bre != 0)
      break;
  }

  node v2;
  forall_adj_nodes(v2,v){
    if(v2 != v1){
      int i=0,j=0;
      node n;
      forall(n,T[v2]){
	if(T[v].search(n) != nil)
	  i++;
	if(T[v1].search(n) != nil)
	  j++;
      }
      if(j > i){
	edge e1 = v_w_edge(T,v,v2);
	edge e2 = T[e1];
	T.del_edge(e1);
	edge e3 = T.new_edge(v1,v2);
	T[e3] = e2;
      }
    }
  }
}

void rep(graph &G,GRAPH<list<node>,edge> &T,list<node> &X_1,list<node> &X_2,list<node> &S,list< list<node> > &F,node v,list<edge> &le){

  T[v].clear();
  node w1;
  forall(w1,X_1)
    T[v].append(w1);
  
  node v1 = T.new_node();
  T[v1].clear();
  node w2;
  forall(w2,X_2)
    T[v1].append(w2);
  
  edge e = T.new_edge(v,v1);
  list_item it = S.first();
  list_item itf;
  while(it != nil){
    list_item it_succ = S.succ(it);
    while(it_succ != nil){
      edge e1 = v_w_edge(G,S[it],S[it_succ]);
      if(le.search(e1) != nil){
	  T[e] = e1;
	  return ;
	}
      it_succ = S.succ(it_succ);
    }
    it = S.succ(it);
  }

}

edge v_w_edge(graph &G,node v,node w){
  edge e;
  forall_adj_edges(e,v)
    if(G.opposite(v,e) == w)
      return e;
}

void f_edge(GRAPH<list<node>,edge> &T,list<node> &kl,node v,list< list<node> > &U_A){
  list_item it = U_A.first();
  node w;
  while(it != nil){
    int count = 0;
    forall(w,U_A[it])
      if(T[v].search(w) != nil)
	count++;
    if(count == U_A[it].size() ){
      kl = U_A[it];
      return ;
    }
    it = U_A.succ(it);
  }
}



/* ************************************************************
   triangulation F $B$r:n@.(B
*************************************************************** */

void triangulation(graph &G,graph &H,list< list<node> > &F,list<edge> &le){
  clock_t start_t = clock();
  node v;
  forall_nodes(v,H)
    operation(G,H,v,F,le);
  clock_t end_t = clock();
  equation += (double)(end_t - start_t) / CLOCKS_PER_SEC;
}

void operation(graph &G,graph &H,node v,list< list<node> > &F,list<edge> &le){
  list<node> C,L,L2;
  node_array<int> node_ord(H,1);
  node_ord[v]=0;
  node v1;
  //C_G(N_H[v])$B$O(Bnode_ord$B$K(B1$B$r$D$1$k(B
  forall_adj_nodes(v1,v)
    node_ord[v1]=0;

  node w;
  //C_G(N_H[v])$B$r(Blist C$B$KJ]B8$9$k(B
  forall_nodes(w,H)
    if(node_ord[w]==1)
      C.append(w);
  while( !C.empty() ){
    c_component(G,H,node_ord,C,L);
    N_G(L,L2);
    if(L2.size() > 1)
      add(G,H,F,L,L2,le);
    L.clear();
    L2.clear();
  }

}

//v1,v2$B4V$K(Bedge$B$,B8:_$7$J$$$+$rH=Dj(B
int edge_exist(node v1,node v2){
  node w;
  if(v1 == v2)
    return 0;

  forall_adj_nodes(w,v1)
    if(w == v2)
      return 0;

  return 1;
}

//connected component C in C_G(N_H[v])
void c_component(graph &G,graph &H,node_array<int> &node_ord,list<node> &C,list<node> &L){
  list_item it = C.first();

  node v = C[it];
  node_ord[v] = 0;
  L.append(v);
  C.erase(it);

  node w;
  forall_adj_nodes(w,v)
    if( node_ord[w]==1 )
      c_component(G,H,node_ord,C,L);
}


void add(graph &G,graph &H,list< list<node> > &F,list<node> &L,list<node> &L2,list<edge> &le){
  list_item it = L2.first();
  list_item it_succ;
  while( it != L2.last() ){
    it_succ = L2.succ(it);
    while( it_succ != nil ){
      if( edge_exist(L2[it],L2[it_succ]) ){
	edge e = H.new_edge(L2[it],L2[it_succ]);
	le.append(e);
	list<node> f1;
	f1.append(L2[it]);
	f1.append(L2[it_succ]);
	F.append(f1);
      }
      it_succ = L2.succ(it_succ);
    }
    it = L.succ(it);
  }
}


/* ********************************************************
   Chromatic_Polynomial
********************************************************** */

void ch_p(graph &G,GRAPH<list<node>,edge > &T,list< list<node> > &F,array<int> &ar,list<edge> &le){
  /*
  GraphWin gw1(G,"ch-p G");
  gw1.display(window::center,window::center);
  gw1.edit();
  */
  if(le.size() == 0){
    //cout << "lemma3" << endl;
    lemma3(G,T,ar);
    //cout << "lemma3 end" << endl;
    return ;
  }
  else{
    edge e;
    forall_edges(e,T)
      if(T[e] == 0){
        //cout << "theorem2 " << endl;
        Theorem2(G,T,F,e,ar);
	//cout << "theorem2 end" << endl;
	return ;
      }
      else{
	//  cout << "theorem1" << endl;
	edge e1 = ChoiseFunction(G,T,F);
	Theorem1(G,T,e1,ar);
	//cout << "theorem1 end" << endl;
	return ;
    }
  }
}


void lemma3(graph &G,GRAPH<list<node>,edge> &T,array<int> &ar){


  int n = G.number_of_nodes();

  list<int> L1,L2;
  node v,w;
  forall_nodes(v,T){
    L1.append(T[v].size());
  }

  edge e;
  forall_edges(e,T){
    v = T.source(e);
    w = T.opposite(v,e);
    int count =0;
    node k;
    forall(k,T[v])
      if(T[w].search(k) != nil)
	count++;
    L2.append(count);
  }

  calculation(ar,L1,L2,n);

  /*
  cout << "--  lemma 3 --" << endl;
  for(int j=n;j>=0;j--){
    cout << ar[j] << "x_"<< j ;
    if(j != 0)
      cout << " + " ;
  }
  cout << endl;
  */

}


void Theorem2(graph &G,GRAPH< list<node>,edge> &T,list< list<node> > &F,edge e,array<int> &ar){
 

  int n = G.number_of_nodes();
  array<int> ar1(n+1);
  array<int> ar2(n+1);
  array<int> ark(n+1);

  graph G1 = G;
  graph G2 = G1;

  for(int i=0;i<=n;i++){
    ar1[i]=0;
    ar2[i]=0;
    ark[i]=0;
  }

  node v = T.source(e);
  node w = T.opposite(v,e);

  Kr(G,T,v,w,ark);

  node_array<int> na1(G,0);
  node_array<int> na2(G,0);

  //G1,G2$B:n@.(B
  m_n(T,G1,na1,v,w);
  m_n(T,G2,na2,w,v);

  m_G(G,G1,na1);
  m_G(G,G2,na2);
  
  G1.make_undirected();
  G2.make_undirected();


  graph H1 = G1;

  graph H2 = G2;

  list< list<node> > F1,F2;
  GRAPH<list<node>,edge> T1,T2;

  list<edge> l1,l2;  


  T1.make_undirected();
  T2.make_undirected();
  

  triangulation(G1,H1,F1,l1);
  triangulation(G2,H2,F2,l2);

  tree(H1,T1,F1,l1);
  tree(H2,T2,F2,l2);

  edge i;
  forall(i,l1)
    H1.del_edge(i);
  forall(i,l2)
    H2.del_edge(i);


  /******************************************

  cout << "----node----" << endl;
  forall_nodes(v,H1){
    cout << v << ": ";
    edge ee;
    forall_adj_edges(ee,v)
      cout << H1.opposite(v,ee) << " ";
    cout << endl;
  }
  cout << endl;
  cout << "-----F-----" << endl;
  list_item it = F1.first();
  while(it != nil){
    F1[it].print(cout,' ');
    cout << endl;
    it=F1.succ(it);
  }

  cout << "T nodes:" << T1.number_of_nodes() << endl;
  forall_nodes(v,T1)
    cout << T1[v].size() << " " << endl;
  cout << endl;

  GraphWin gw1(H1,"theorem2 G");
  gw1.display(window::center,window::center);
  gw1.edit();

  *************************************** */

  //cout << "G1  theorem2 -> ";

  ch_p(H1,T1,F1,ar1,l1);
  //cout << "G2  theorem2 -> ";
  ch_p(H2,T2,F2,ar2,l2);

  cul2(ar,ar1,ar2,ark,n);
}

void cul2(array<int> &ar,array<int> &ar1,array<int> &ar2,array<int> &ark,int n)
{
  array<int> ex(n+1);
  for(int i=0;i<=n;i++)
    ex[i]=0;

  int a,b,c=0;
  for(int i=n;i>0;i--)
    if(ar1[i]!=0){
      a=i;
      break;
    }
  for(int i=n;i>0;i--)
    if(ar2[i]!=0){
      b=i;
      break;
    }
  for(int i=n;i>0;i--)
    if(ark[i]!=0){
      c=i;
      break;
    }


  /*
  for(int j=n;j>=0;j--){
    cout << ar1[j] << "x_"<< j ;
    if(j != 0)
      cout << " + " ;
  }
  cout << endl;
  for(int j=n;j>=0;j--){
    cout << ar2[j] << "x_"<< j ;
    if(j != 0)
      cout << " + " ;
  }
  cout << endl;
  for(int j=n;j>=0;j--){
    cout << ark[j] << "x_"<< j ;
    if(j != 0)
      cout << " + " ;
  }
  cout << endl;
  */
  int b1 = b;
  int q;
  if(c != 0){
    for(int i=b-c;i>=0;i--){
      q=ar2[b1] / ark[c];
      ex[i]=q;
      for(int j=c;j>0;j--)
	ar2[i+j]=ar2[i+j]-ark[j]*q;
      b1--;
    }
  }
  else ex = ar2;

  for(int i=0;i<=b-c;i++)
    for(int j=0;j<=a;j++)
      ar[i+j] += ex[i]*ar1[j];


}

void m_n(GRAPH<list<node>,edge> &T,graph &G,node_array<int> &na,node v,node w){
  node k;
  forall(k,T[v])
    na[k] = 1;
  
  forall_adj_nodes(k,v)
    if(k != w)
      m_n(T,G,na,k,v);
}

void m_G(graph &G,graph &G1,node_array<int> &na){
  node v;
  list<int> L;
  int count =0;
  forall_nodes(v,G){
    if(na[v] == 0)
      L.append(count);
    count++;
  }
  int num =0;
  forall_nodes(v,G1){
    if(L.search(num) != nil)
      G1.del_node(v);
    num++;
  }
}

void Kr(graph &G,GRAPH<list<node>,edge> &T,node v,node w,array<int> &ar)
{
  node_array<int> na(G,0);
  list<node> L;
  node k;
  forall(k,T[v])
    na[k]=1;
  forall(k,T[w])
    if(na[k] == 1)
      L.append(k);
  int n=G.number_of_nodes();

  calk(L.size(),ar,n);
}

void calk(int size,array<int> &ar,int n){
  array<int> p(n+1);
  ar[1]=1;
  ar[0]=0;
  p=ar;
  for(int i=1;i<size;i++){
    for(int j=1;j<=i+1;j++){
      ar[j]  = ar[j]*(-1)*i;
      ar[j] += p[j-1];
    }
    p = ar;
  }
}

void calculation(array<int> &ar,list<int> L1,list<int> L2,int n){
  list_item it1;
  list_item it2;

  /*
 
  cout << "L1 ; ";
  L1.print(cout,' ');
  cout << endl;
  cout << "L2 ; ";
  L2.print(cout,' ');
  cout << endl;
  */

  L1.sort();
  L2.sort();

  forall_items(it2,L2){
    it1 = L1.search(L2[it2]);
    if(it1 != nil){
      L1.erase(it1);
      L2.erase(it2);
    }
  }

  it1 = L1.first();
  it2 = L2.first();

  int x = L1[it1];
  L1.erase(it1);
  array<int> p(n+1);
  ar[1]=1;
  ar[0]=0;
  p=ar;
  for(int i=1;i<x;i++){
    for(int j=1;j<=i+1;j++){
      ar[j]  = ar[j]*(-1)*i;
      ar[j] += p[j-1];
    }
    p = ar;
  }


  forall_items(it1,L1){
    int x = L1[it1];
    int y = L2[it2];
    while(x < y){
      it2 = L2.succ(it2);
      y = L2[it2];
    }
    for(int i=y;i<x;i++){
     for(int j=1;j<=n;j++){
       ar[j]=ar[j]*(-1)*i;
       ar[j]+=p[j-1];
     }
    p = ar;
    }
    L2.erase(it2);
    it2 = L2.first();
  }

}

 
edge ChoiseFunction(graph &G,GRAPH<list<node>,edge> &T,list< list<node> > &F){
  int N = T.number_of_nodes();

  //find tree egde e: left subtree's number of nodes == right 
  edge e_T = find_tree_edge(T,N);

  node k1 = T.source(e_T);
  node k2 = T.opposite(k1,e_T);
  
  //find graph edges e' in tree edge e
  list<node> dummy_s;
  dummy_s.clear();
  node I;
  forall(I,T[k1])
    if(T[k2].search(I) != nil)
      dummy_s.append(I);

  //find graph edge e' used most in graph edges e'
  if( N != 2 ){
    int max = 0;
    list_item it=F.first();
    list_item max_it=F.first();
    list<node> ln;
    ln.clear();
    while(it != nil){
      list_item Fit1 = F[it].first();
      list_item Fit2 = F[it].succ(Fit1);
      node v = F[it][Fit1];
      node w = F[it][Fit2];
      int count = 0;
      edge e;
      forall_edges(e,T){
	node n1 = T.source(e);
	node n2 = T.opposite(n1,e);
	if( dummy_s.search(v) && dummy_s.search(w)&& T[n1].search(v) && T[n1].search(w) && T[n2].search(v) && T[n2].search(w))
	  count++;
      }
      if(count > max){
	max = count;
	ln.clear();
	ln.append(v);
	ln.append(w);
	max_it = it;
      }
      it = F.succ(it);
    }
    list_item it1 = ln.first();
    list_item it2 = ln.succ(it1);
    edge e1 = G.new_edge(ln[it1],ln[it2]);
    F.erase(max_it);
    return e1;
  }
  else{
    list_item it = F.first();
    list_item itv,itw;
    node v,w;
    itv = F[it].first();
    itw = F[it].succ(itv);
    edge e1 = G.new_edge(F[it][itv],F[it][itw]);
    F.erase(it);
    return e1;
  }
}

  //find tree egde e: left subtree's number of nodes == right 
edge find_tree_edge(GRAPH<list<node>,edge> &T,int N){
 
  edge e;
  node m1,m2;
  int i,left,right;
  if(N%2==0)
    i=0;
  else
    i=1;
  while(1){        /*(i<N)*/
    forall_edges(e,T){

      if(T[e]!=0){
	m1 = T.source(e);
	m2 = T.opposite(m1,e);
      
	//subtree's number of nodes
	left = zentan_haba(T,m1,m2);
	right  = N - left;
	
	if((left - right == i) || (right - left == i)){
	  return e;
	}
      }
    }
    i+=2;
  }
}

//subtree's number of nodes
int zentan_haba(GRAPH<list<node>,edge> &T, node m1, node m2){

  list<node> Q;
  node_array<int> visit(T,-1);
  node x;
  int num = 0;
  visit[m2]=1;
  Q.append(m1);
  visit[m1]=1;
  while (!Q.empty()){
    m1=Q.pop();
    forall_adj_nodes(x,m1){
      if(visit[x]==-1){
	Q.append(x);
	visit[x]=1;
	num++;
      }
    }
  }
  return num;
}

void Theorem1(graph &G,GRAPH<list<node>,edge> &T,edge e,array<int> &ar){

  int n = G.number_of_nodes();
  array<int> ar1(n+1);
  array<int> ar2(n+1);

  for(int i=0;i<=n;i++){
    ar1[i]=0;
    ar2[i]=0;
  }

  graph G1 = G;

  //G.write("g.gw");
  //G1.write("g1.gw");
  //exit(1);
  contraction(G,e);
  graph G2 = G;

  G1.make_undirected();
  G2.make_undirected();
  
  graph H1 = G1;

  graph H2 = G2;

  
  list< list<node> > F1,F2;
  GRAPH<list<node>,edge> T1,T2;

  list<edge> l1,l2;  

  T1.make_undirected();
  T2.make_undirected();
  

  triangulation(G1,H1,F1,l1);
  triangulation(G2,H2,F2,l2);

  tree(H1,T1,F1,l1);
  tree(H2,T2,F2,l2);

  edge i;
  forall(i,l1)
    H1.del_edge(i);
  forall(i,l2)
    H2.del_edge(i);

  /* ******************************************

  GraphWin gw1(G1,"G1");
  gw1.display(window::center,window::center);
  gw1.edit();

  GraphWin gw2(G2,"G2");
  gw2.display(window::center,window::center);
  gw2.edit();


  ******************************************** */
  //cout << "G1  theorem1 -> ";
  ch_p(H1,T1,F1,ar1,l1);
  //cout << "G2  theorem1 -> ";
  ch_p(H2,T2,F2,ar2,l2);

  for(int i=0;i<=n;i++)
    ar[i] = ar1[i] + ar2[i];

}


void contraction(graph &G,edge e){


  G.make_undirected();

  node v,w,x;
  v = G.source(e);
  w = G.opposite(v,e);

  node_array<int> node_ord(G,0);


  forall_adj_nodes(x,v)
    node_ord[x]=1;

  forall_adj_nodes(x,w)
    node_ord[x]=1;
  node_ord[v]=0;
  node_ord[w]=0;

  node new_v=G.new_node();
  forall_nodes(x,G)
    if(x != new_v)
      if(node_ord[x] == 1)
	G.new_edge(new_v,x);
  G.del_node(v);
  G.del_node(w);
}

